#include <fstream.h>
#include <iostream.h>
#include <string.h>
#include <strstream.h>
#include <iomanip.h>
#include <stdlib.h>

void errormessage(char*);

main(int argc, char* argv[]) {

    if (argc != 2 || !(strcmp(argv[1], "--help"))) {
        cout << "Usage: make_string [ target filename]" << endl;
		exit(0);
    }

    int outfilenamesize = strlen(argv[1]);
    char* outname;
    char* inname;
    if (!(inname = new char[outfilenamesize + 1])) errormessage("Memory allocation error");
    if (!(outname = new char[outfilenamesize + 5])) errormessage("Memory allocation error");
    strcpy(inname, argv[1]);
    strcpy(outname, argv[1]);
    strcat(outname, ".str");
    
    ifstream infile(inname, ios::in | ios:: bin | ios::nocreate);
    if (!infile) errormessage("Cannot open file to be converted");
    ofstream outfile(outname, ios::out | ios:: bin);
    if (!outfile) errormessage("Cannot open file to be written to");
    char letter;
    
    outfile.put('"');
    while(infile.get(letter)) {
        if (letter == '\n') {
	    outfile.put('\\');
	    outfile.put('n');
	    outfile.put('"');
	    outfile.put('\n');
	    outfile.put('"');
	}
	else if (letter == '"') {
	    outfile.put('\\');
            outfile.put('"');
        }
        else outfile.put(letter);
    }
}

void errormessage(char* message) {
    cerr << "\n" << message << "\n" << endl;
    exit(1);
}
